<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void update(AzureDao dao){
	AzureData data = new AzureData();
	data.id = paramInt("id");
	data.azClientId = paramString("azClientId");
	data.azClientSecret = paramString("azClientSecret");
	data.azTenantId = paramString("azTenantId");
	data.period = paramInt("period");

	// Param validation.
	if (isEmpty(data.azClientId)) {
		errList.add(translate("Application ID missing."));
		return;
	}

	if (isEmpty(data.azClientSecret)) {
		errList.add(translate("Client Secret missing."));
		return;
	}

	if (isEmpty(data.azTenantId)) {
		errList.add(translate("Directory ID missing."));
		return;
	}

	if(dao.update(data)){
		succList.add(translate("Update finished."));
	}
}

//-----------------------------------------------
void loginTest(AzureDao dao){
	try{
		AzureData azData = dao.selectOne(paramInt("id"));
		
		if(AzureDao.login(azData.azClientId, paramString("uname"), paramString("passwd"))){
			succList.add(translate("User login succeeded."));
		}
		else{
			succList.add(translate("User login process has been completed."));
		}
	}
	catch(Exception e){
		errList.add(e.toString());
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();
permission.addSubAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
AzureDao dao = new AzureDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	update(dao);
}
if(actionFlag.equals("loginTest")){
	loginTest(dao);
}

// Global.
AzureData data = dao.selectOne(paramInt("id"));

// Active tab.
String tabActive0 = "";
String tabActive1 = "";

String showActive0 = "";
String showActive1 = "";

int tabIdx = paramInt("tabIdx");
if(tabIdx == 0){
	tabActive0 = " active";
	showActive0 = " show active";
}
else if(tabIdx == 1){
	tabActive1 = " active";
	showActive1 = " show active";
}
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item"><%= translate("USER")%></li>
		<li class="breadcrumb-item clickable-li" onclick="window.location.href='user,azure.jsp';"><%= translate("AZURE DIRECTORY")%></li>
		<li class="breadcrumb-item text-info"><%= translate("EDIT")%></li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<!-- Tab -->
	<div>
		<ul class="nav nav-tabs" style="margin-left:10px; margin-right:10px;">
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(0);">
				<a class="nav-link<%= tabActive0%>" data-toggle="tab" href="#tab0"><%= translate("EDIT")%></a>
			</li>
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(1);">
				<a class="nav-link<%= tabActive1%>" data-toggle="tab" href="#tab1"><%= translate("LOGIN TEST")%></a>
			</li>
		</ul>
	</div>
	<!-- Tab -->

	<!-- Form -->
	<form action="<%= getPageName()%>" method="post">
		<input type="hidden" name="actionFlag" value="update">
		<input type="hidden" id="tabIdx" name="tabIdx" value="<%= tabIdx%>">
		<input type="hidden" name="id" value="<%= data.id%>">
  
		<!-- Tab content -->
		<div id="myTabContent" class="tab-content">

			<!-- Edit -->
			<div class="tab-pane <%= showActive0%>" id="tab0">
				<div class="card bg-light m-2 expand-lg">
					<div class="card-body">
						<fieldset>
							<div class="form-group col-lg-8">
								<label class="col-form-label"><%= translate("Domain")%></label>
								<input type="text" class="form-control" id="domain" name="domain" value="<%= data.domain%>" disabled>
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label">
									<%= translate("Application ID")%>
								</label>
								<input type="text" class="form-control" id="azClientId" name="azClientId" value="<%= data.azClientId%>">
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label">
									<%= translate("Directory ID")%>
								</label>
								<input type="text" class="form-control" id="azTenantId" name="azTenantId" value="<%= data.azTenantId%>">
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label"><%= translate("Client Secret Value")%></label>
								<div class="input-group">
									<input type="password" class="form-control" id="azClientSecret" name="azClientSecret" value="<%= data.azClientSecret%>">
									<button class="btn btn-info" type="button" id="show-hide-secret">Show/Hide</button>
								</div>
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label"><%= translate("Auto-sync")%></label>
								<select class="form-control" id="period" name="period">
<%
Map<Integer, String> periodMap = getLdapPeriodMap();
for(Map.Entry<Integer, String> entry : periodMap.entrySet()){
	Integer key = entry.getKey();
	String val = entry.getValue();

	if(key == data.period){
		printf("<option value='%s' selected>%s</option>\n", key, translate(val));
	}
	else{
		printf("<option value='%s'>%s</option>\n", key, translate(val));
	}
}
%>
								</select>
							</div>
							<div class="form-group col-lg-8">
								<button type="button" class="btn btn-primary" onclick="javascript:actionUpdate(this.form);"><%= translate("SUBMIT")%></button>
							</div>
						</fieldset>
					</div>
				</div>
			</div>
			<!-- /Edit -->

			<!-- LOGIN TEST -->
			<div class="tab-pane fade<%= showActive1%>" id="tab1">
				<div class="card bg-light m-2 expand-lg">
					<div class="card-body">
						<fieldset>
							<div class="form-group col-lg-8 text-secondary">
								<%= translate("You can test user login to your Azure Active Directory here.", 1000)%>
							</div>

							<div class="form-group col-lg-8">
								<label class="col-form-label"><%= translate("Username")%></label>
								<input type="text" class="form-control" id="uname" name="uname">
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label"><%= translate("Password")%></label>
								<div class="input-group">
									<input type="password" class="form-control" id="passwd"	name="passwd">
									<button class="btn btn-info" type="button" id="show-hide-passwd">Show/Hide</button>
								</div>
							</div>
							<div class="form-group col-lg-8">
								<button type="button" class="btn btn-primary" onclick="javascript:actionLoginTest(this.form);"><%= translate("LOGIN TEST")%></button>
							</div>
						</fieldset>
					</div>
				</div>
			</div>
			<!-- /LOGIN TEST -->

	</form>
	<!-- /Form -->

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>

<script>
//-----------------------------------------------
function actionUpdate(form){
	form.submit();
}

//-----------------------------------------------
function actionLoginTest(form){
	form.actionFlag.value = "loginTest";
	form.submit();
}

//-----------------------------------------------
$(document).ready(function() {
	$("#show-hide-passwd").on("click", function(event) {
		event.preventDefault();
		if($("#passwd").attr("type") == "text"){
			$("#passwd").attr("type", "password");
		}
		else if($("#passwd").attr("type") == "password"){
			$("#passwd").attr("type", "text");
		}
	});

	$("#show-hide-secret").on("click", function(event) {
		event.preventDefault();
		if($("#azClientSecret").attr("type") == "text"){
			$("#azClientSecret").attr("type", "password");
		}
		else if($("#azClientSecret").attr("type") == "password"){
			$("#azClientSecret").attr("type", "text");
		}
	});
});
</script>
